Subject: RE: question on reserve and release !

From: [email-masked]
Date: Mon, 21 Oct 2002 20:46:23 -0400

> > I have a question on how iscsi will handle the scsi reserve
> > and release commands.
> > 
> > When multiple iscsi initiators make calls to the same iscsi 
> > target, the actual scsi device only sees one single scsi id
> > (that of the scsi HBA on the iscsi target machine).  This
> > would mean that different iscsi initiators sending scsi reserve
> > command will be interpreted by the scsi target as commands
> > from the same scsi initiator.

Which in turn would mean that the implementation of the iscsi to
parallel scsi gateway is broken.  SCSI is *not* an end to end
protocol whose CDBs can be transparently passed through when
changing transports.  For this example, the iscsi to scsi gateway
either has to present multiple initiators to the target or has
to implement the reserve and release functionality itself on
behalf of the target (which should then not be connected externally
via any means other than this gateway).

Thanks,
--David
----------------------------------------------------
David L. Black, Senior Technologist
EMC Corporation, 176 South St., Hopkinton, MA  01748
+1 (508) 293-7953 **NEW**     FAX: +1 (508) 293-7786
[email-masked]        Mobile: +1 (978) 394-7754
----------------------------------------------------

---

From: "YP Cheng" <[email-masked]>
Date: Tue, 22 Oct 2002 10:18:45 -0700

> via any means other than this gateway).

I'm confused by the above statements.  In a selection phase of parallel
SCSI, one does know the Host ID bit on the SCSI bus.  Hence, only one
initiator can reserve at a time.  Others gets "Reserve Conflict - Status
08".  For iSCSI, different initiators have their own respective sessions.
The iSCSI to parallel SCSI gateway can easily emulating a Host ID bit -
although it would need multiple logical SCSI busses when the number of
initiators exceeds 15 on a wide SCSI bus.

Y.P. Cheng
Chief Scientist, Matisse Networks.